<?php

namespace App\Lib\Unifaun\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for book StructType
 * Meta information extracted from the WSDL
 * - type: tns:book
 * @subpackage Structs
 */
class Book extends AbstractStructBase
{
    /**
     * The AuthenticationToken
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \App\Lib\Unifaun\StructType\AuthenticationToken
     */
    public $AuthenticationToken;
    /**
     * The Consignment
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \App\Lib\Unifaun\StructType\Consignment
     */
    public $Consignment;
    /**
     * The transactionId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $transactionId;
    /**
     * Constructor method for book
     * @uses Book::setAuthenticationToken()
     * @uses Book::setConsignment()
     * @uses Book::setTransactionId()
     * @param \App\Lib\Unifaun\StructType\AuthenticationToken $authenticationToken
     * @param \App\Lib\Unifaun\StructType\Consignment $consignment
     * @param string $transactionId
     */
    public function __construct(\App\Lib\Unifaun\StructType\AuthenticationToken $authenticationToken = null, \App\Lib\Unifaun\StructType\Consignment $consignment = null, $transactionId = null)
    {
        $this
            ->setAuthenticationToken($authenticationToken)
            ->setConsignment($consignment)
            ->setTransactionId($transactionId);
    }
    /**
     * Get AuthenticationToken value
     * @return \App\Lib\Unifaun\StructType\AuthenticationToken|null
     */
    public function getAuthenticationToken()
    {
        return $this->AuthenticationToken;
    }
    /**
     * Set AuthenticationToken value
     * @param \App\Lib\Unifaun\StructType\AuthenticationToken $authenticationToken
     * @return \App\Lib\Unifaun\StructType\Book
     */
    public function setAuthenticationToken(\App\Lib\Unifaun\StructType\AuthenticationToken $authenticationToken = null)
    {
        $this->AuthenticationToken = $authenticationToken;
        return $this;
    }
    /**
     * Get Consignment value
     * @return \App\Lib\Unifaun\StructType\Consignment|null
     */
    public function getConsignment()
    {
        return $this->Consignment;
    }
    /**
     * Set Consignment value
     * @param \App\Lib\Unifaun\StructType\Consignment $consignment
     * @return \App\Lib\Unifaun\StructType\Book
     */
    public function setConsignment(\App\Lib\Unifaun\StructType\Consignment $consignment = null)
    {
        $this->Consignment = $consignment;
        return $this;
    }
    /**
     * Get transactionId value
     * @return string|null
     */
    public function getTransactionId()
    {
        return $this->transactionId;
    }
    /**
     * Set transactionId value
     * @param string $transactionId
     * @return \App\Lib\Unifaun\StructType\Book
     */
    public function setTransactionId($transactionId = null)
    {
        // validation for constraint: string
        if (!is_null($transactionId) && !is_string($transactionId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionId, true), gettype($transactionId)), __LINE__);
        }
        $this->transactionId = $transactionId;
        return $this;
    }
}
